package iotcloud;

import java.util.Arrays;

final public class IoTString {
	byte[] array;
	int hashcode;

	private IoTString() {
	}

	public IoTString(byte[] _array) {
		array=(byte[]) _array.clone();
		hashcode=Arrays.hashCode(array);
	}

	public IoTString(String str) {
		array=str.getBytes();
		hashcode=Arrays.hashCode(array);
	}

	static IoTString shallow(byte[] _array) {
		IoTString i=new IoTString();
		i.array = _array;
		i.hashcode = Arrays.hashCode(_array);
		return i;
	}

	byte[] internalBytes() {
		return array;
	}

	public int hashCode() {
		return hashcode;
	}

	public String toString() {
		return new String(array);
	}

	public byte[] getBytes() {
		return (byte[]) array.clone();
	}

	public boolean equals(Object o) {
		if (o instanceof IoTString) {
			IoTString i=(IoTString)o;
			return Arrays.equals(array, i.array);
		}
		return false;
	}

	public int length() {
		return array.length;
	}
}
