package iotcloud;

import java.nio.ByteBuffer;

class LastMessage extends Entry {
	private long machineid;
	private long seqnum;

	LastMessage(Slot slot, long _machineid, long _seqnum) {
		super(slot);
		machineid=_machineid;
		seqnum=_seqnum;
	}

	long getMachineID() {
		return machineid;
	}

	long getSequenceNumber() {
		return seqnum;
	}

	static Entry decode(Slot slot, ByteBuffer bb) {
		long machineid=bb.getLong();
		long seqnum=bb.getLong();
		return new LastMessage(slot, machineid, seqnum);
	}

	void encode(ByteBuffer bb) {
		bb.put(Entry.TypeLastMessage);
		bb.putLong(machineid);
		bb.putLong(seqnum);
	}

	int getSize() {
		return 2*Long.BYTES+Byte.BYTES;
	}

	byte getType() {
		return Entry.TypeLastMessage;
	}
}


