package iotcloud;
import java.nio.ByteBuffer;

class TableStatus extends Entry {
	private int maxslots;

	TableStatus(Slot slot, int _maxslots) {
		super(slot);
		maxslots=_maxslots;
	}

	int getMaxSlots() {
		return maxslots;
	}

	static Entry decode(Slot slot, ByteBuffer bb) {
		int maxslots=bb.getInt();
		return new TableStatus(slot, maxslots);
	}

	void encode(ByteBuffer bb) {
		bb.put(Entry.TypeTableStatus);
		bb.putInt(maxslots);
	}

	int getSize() {
		return Integer.BYTES+Byte.BYTES;
	}

	byte getType() {
		return Entry.TypeTableStatus;
	}
}
