package iotcloud;
import java.io.*;
import java.net.*;
import java.util.Arrays;
import javax.crypto.*;

class TestCloudComm extends CloudComm {
	SlotBuffer buffer;

	TestCloudComm() {
		buffer = new SlotBuffer();
	}

	public synchronized Slot[] putSlot(Slot slot, int max) {
		if ((buffer.size()==0 && 1 == slot.getSequenceNumber()) ||
				buffer.getNewestSeqNum()+1 == slot.getSequenceNumber()) {
			if (max!=0)
				buffer.resize(max);
			buffer.putSlot(slot);
			return null;
		} else
			return getSlots(slot.getSequenceNumber());
	}

	public synchronized Slot[] getSlots(long sequencenumber) {
		long newestseqnum=buffer.getNewestSeqNum();
		long oldestseqnum=buffer.getOldestSeqNum();
		if (sequencenumber < oldestseqnum)
			sequencenumber=oldestseqnum;
		int numslots=(int)((newestseqnum - sequencenumber)+1);
		Slot[] slots=new Slot[numslots];
		for(int i=0; i<numslots; i++,sequencenumber++)
			slots[i]=buffer.getSlot(sequencenumber);
		return slots;
	}
}
